#define PY_SSIZE_T_CLEAN
#include <Python.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <mcrypt.h>
#include <time.h>

#define mset "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

char * decryptBlowfishCfb(const char * encrStr, int count, char ** output, char * encrkey) {
	MCRYPT td;
	char IV[10];
	int len ;

	char block_buffer[count * 5];
	memset(block_buffer, 0, sizeof(block_buffer));
	strncpy(block_buffer, encrStr, count);

	memset(IV, 0, 10);
	strncpy(IV, &block_buffer[count-8], 8);
	block_buffer[count-8] = '\0';
	td = mcrypt_module_open(MCRYPT_BLOWFISH, NULL, MCRYPT_CFB, NULL);
	mcrypt_generic_init(td, encrkey, strlen(encrkey), IV);
	mdecrypt_generic(td, &block_buffer, count-8);
	mcrypt_generic_deinit(td);
	mcrypt_module_close(td);

	len = strlen(block_buffer) + 1;
	*output = (char *)malloc(len);
	memset(*output, 0, len);
	strcpy(*output, block_buffer);

	return *output;
}

char * encryptBlowfishCfb(const char * inStr, Py_ssize_t *count, char * output, char * encrkey) {
	MCRYPT td;
	char IV[10];
	int len, i;
	char block_buffer[512];
	time_t t;

	srand((unsigned) time(&t));
	strcpy(IV, "");
	for (i = 0 ; i < 8 ; i++ ) {
		IV[i] =  mset[(rand() % 62)];
	}
	td = mcrypt_module_open(MCRYPT_BLOWFISH, NULL, MCRYPT_CFB, NULL);
	mcrypt_generic_init(td, encrkey, strlen(encrkey), IV);
	memset(block_buffer, 0, sizeof(block_buffer));
	strcpy(block_buffer, inStr);
	i = strlen(inStr);
	mcrypt_generic(td, &block_buffer, i);
	block_buffer[i] = '\0';
	strcpy(&block_buffer[i], IV);
	mcrypt_generic_deinit(td);
	mcrypt_module_close(td);

	len = i + 8 + 1;
	memset(output, 0, 512);
	memcpy(output, block_buffer, len -1);
	*count = i + 8;

	return output;
}



static PyObject *method_encrypt(PyObject *self, PyObject *args) {
	char *keyval, *str = NULL, output[512];
	Py_ssize_t count=0;
	PyObject *retval;

	if(!PyArg_ParseTuple(args, "ss", &str, &keyval)) {
		return NULL;
	}

	encryptBlowfishCfb(str, &count, output, keyval);

	//retval = Py_BuildValue("y#", output, count);
	retval = PyBytes_FromStringAndSize(output, count);
	if (!retval) printf(".");
	//printf(".");
	//sleep(1);
	return retval;
}

static PyObject * method_decrypt(PyObject* self, PyObject* args)
{
	const char *str;
	char *decrypted, *keyval;
	Py_ssize_t count;
	PyObject *retval;

	if (!PyArg_ParseTuple(args, "s#s", &str, &count, &keyval))
	{
		return NULL;
	}

	decryptBlowfishCfb(str, count, &decrypted, keyval);

	retval = PyUnicode_FromString(decrypted);
	free(decrypted);

	return retval;
}

static PyMethodDef tdc_cryptMethods[] = {
		{"encrypt", method_encrypt, METH_VARARGS, "Python interface for encrypt C library function"},
		{"decrypt", method_decrypt, METH_VARARGS, "Python interface for decrypt C library function"},
		{NULL, NULL, 0, NULL}
};

static struct PyModuleDef sarahcryptmodule = {
		PyModuleDef_HEAD_INIT,
		"sarahcrypt",
		"Python interface for the encrypt/decrypt C library functions",
		-1,
		tdc_cryptMethods
};

PyMODINIT_FUNC PyInit_sarahcrypt(void) {
	return PyModule_Create(&sarahcryptmodule);
}